precision lowp float;

uniform sampler2D uTexture;
uniform float uAlphaScale;
uniform vec4 uContent;
varying vec2 vTexCoord;
uniform vec4 uColor;
uniform vec4 uColorToRemove;

void main() {
    if(vTexCoord.x > uContent.x && vTexCoord.x < uContent.z
        && vTexCoord.y > uContent.y && vTexCoord.y < uContent.w) { 
        vec4 textureColor  = texture2D(uTexture, vTexCoord); 
        if(textureColor.r == uColorToRemove.r && textureColor.g == uColorToRemove.g && textureColor.b == uColorToRemove.b){
            textureColor.rgba= vec4(0.0); 
        }else{
            textureColor.rgb = uColor.rgb;
            textureColor *= uAlphaScale;
            if(textureColor.a > 0.0 ){
                textureColor.a=1.0;
            } 
        }
        gl_FragColor=textureColor;
    }
}