attribute vec4 aPosition;
attribute vec4 aColor;
attribute float aWeight;
uniform mat4 uTransform;
uniform float uPointSize;
uniform vec4 uWeightParams;
varying vec4 vColor;
uniform vec4 uContent;

void main() {
    gl_Position = uTransform * aPosition;
    gl_PointSize = uPointSize;
    vColor = aColor;
    float weight =  aWeight * aWeight;

    float ratioColorLight = uWeightParams[0];
    float ratioColorHeavy = uWeightParams[1];
    float weightColorLight = uWeightParams[2];
    float weightColorHeavy = uWeightParams[3];

    weight = clamp(weight, weightColorLight, weightColorHeavy);

    float ratioWeight = (weight - weightColorLight) / (weightColorHeavy - weightColorLight);

    float ratio = ratioColorLight + (ratioWeight * (ratioColorHeavy - ratioColorLight));

    // Modulate the color by weight, if the weight is above the cutoff.
    vColor.rgb *= ratio;

    if(aPosition.x < uContent.x || aPosition.x > uContent.z
        || aPosition.y > uContent.y || aPosition.y < uContent.w) {
        vColor *= 0.0;
    }

    vColor.rgb = clamp(vColor.rgb, 0.0, 1.0);
}
